#include <locale.h>
#include <stdio.h>
#include <string.h>

#include "Test.h"
#include "Tests.h"
#include "core/Logger.h"
#include "core/Utility.h"

static void onExit(int code, void* data) {
    unsigned int i = *(unsigned int*)(data);
    CORE_LOG_WARNING("Hello from exit %d: %u", code, i);
    coreFinalizeTests();
    corePrintMemoryReport();
}

int main(int argAmount, const char** args) {
    setlocale(LC_ALL, "en_US.utf8");
    bool light = false;
    for(int i = 0; i < argAmount; i++) {
        if(strcmp(args[i], "light") == 0) {
            light = true;
        } else if(strcmp(args[i], "alloc") == 0) {
            coreTestInvalidAllocate();
        } else if(strcmp(args[i], "realloc") == 0) {
            coreTestInvalidReallocate();
        } else if(strcmp(args[i], "pre_canary") == 0) {
            coreTestPreCanary();
        } else if(strcmp(args[i], "post_canary") == 0) {
            coreTestPostCanary();
        }
    }

    coreTestBitArray();
    // coreTestComponents();
    // coreTestHashMap(light);
    // coreTestLinkedList(light);
    // coreTestMatrixStack(light);
    // coreTestRingBuffer();
    // coreTestStack(light);
    coreTestBox();
    coreTestBuffer(light);
    coreTestFrustum();
    coreTestList(light);
    coreTestMatrix();
    coreTestPlane();
    coreTestQuaternion();
    coreTestRandom(light);
    coreTestSpinLock();
    coreTestUtility(light);
    coreTestVector();
    coreTestView();

    coreLogLevel = CORE_LOG_WARNING;
    CORE_LOG_DEBUG("You won't see this!");
    coreLogLevel = CORE_LOG_DEBUG;

    unsigned int data = 123456789;
    coreSetExitHandler(onExit, &data);

    CORE_EXIT(1);
}
